# Backend internal interview (rust) - basic-fixed  

> [!Tip]
> Use [Improve branch](/jesus/be-technical-interview-rust/src/branch/improved) as a full refactoring for <u>better quality, maintenance and readability</u>. (Structs, implementaitions, settings for multiple inputs, etc).

> [!NOTE]
> Code in this branch simply **works as expected** trying to be preserve initial approach and not too much disruptive changes.<br>
> It is able to **process multiple metrics in parallel** (input.txt and input_2.txt). <br>
> A full refactoring has to be done for <u>better quality, maintenance and be more readable</u>. (Structs, implementaitions, settings for multiple inputs, etc). <br>

> [!CAUTION]
> [Improve branch](/jesus/be-technical-interview-rust/src/branch/improved) should try to make code more modular and simple, avoid hardcoding, etc.

See [main changes](/jesus/be-technical-interview-rust/src/branch/basic-fixed/CHANGES.md)

A **Refactor metric-consumer** task

[Home Task exercise description](Home-Task_exercise_interview_Rust.pdf)

There are several branches developed as proposal:

- [Basic fixed one](/jesus/be-technical-interview-rust/src/branch/basic-fixed)
  > A basic code review, fixed with minor and essential changes to work as expected. <br>
  > Tests are included for verification.

- [Improve one](/jesus/be-technical-interview-rust/src/branch/improved)

- [x]  Define a basic model, easily to extend and modify. **Abstraction / Generic**.
- [x]  Structs and implementations to specific metricis traitments. **Modular appoach**.
- [x]  Settings and configuration for interactive and non interactive processing (batch mode) **Customize on context**.
